import { SocketEvent } from '@/socket/socket-event';
import {
  Config,
  IDictionary,
  IEventParam,
} from '@zeedhi/core';
import { ZdTreeGrid } from '@zeedhi/vuetify';
import { io, Socket } from 'socket.io-client';

export class SystemController {
  public socket?: Socket;

  /**
   * Método executado quando o grid é criado
   */
  public gridMounted({ component }: IEventParam<ZdTreeGrid>) {
    // inicializa o socket
    this.socket = io(Config.endPoint, {
      transports: ['websocket', 'polling'],
    });

    this.socket.off(SocketEvent.CONNECTION)
      .emit('infoSystemMonitoramento', {
        slave: false,
      });

    this.socket.off(SocketEvent.CONNECTION)
      .on('infoSystemMonitoramento', async (branc: IDictionary) => {
        await component.datasource.updateData(branc.message.data);
        await component.datasource.get();
      });
  }

  public visibleConditionStatus() {
    // let cor;

    // [row].forEach((element:any) => {
    //   if (element.v === '-' || element.vd !== '') {
    //     cor = 'red';
    //   } else {
    //     cor = 'green';
    //   }
    // });

    // return cor;
  }

  public visibleConditionCorrigir() {
    // let up = false;
    // if (row.v === '-' || row.vd.length === 0) {
    //   up = false;
    // } else {
    //   up = true;
    // }
    // return up;
  }

  /**
   * Método executado logo antes do grid ser destruído
   */
  public gridBeforeDestroy() {

  }
}
